package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.TSSDTaskPolicyMapper;
import com.sa.ibiz.demo.demo.domain.TSSDTaskPolicy;
import com.sa.ibiz.demo.demo.service.TSSDTaskPolicyService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.TSSDTaskPolicySearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.TSSDPolicyService;
import com.sa.ibiz.demo.demo.service.TSSDTaskService;

/**
 * 实体[TSSDTaskPolicy] 服务对象接口实现
 */
@Service
public class TSSDTaskPolicyServiceImpl extends ServiceImplBase<TSSDTaskPolicyMapper, TSSDTaskPolicy> implements TSSDTaskPolicyService{

    @Autowired
    private TSSDPolicyService tssdpolicyService;
    @Autowired
    private TSSDTaskService tssdtaskService;

    @Resource
    private TSSDTaskPolicyMapper tssdtaskpolicyMapper;


    @Override
    public boolean create(TSSDTaskPolicy et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(TSSDTaskPolicy et){
        this.beforeUpdate(et);
		this.tssdtaskpolicyMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(TSSDTaskPolicy et){
		return et.getTssdtaskpolicyid();  
    }

    @Override
    public boolean getDraft(TSSDTaskPolicy et)  {
    if((!StringUtils.isEmpty(et.getTssdpolicyid())) && et.getTssdpolicy() == null){
            try {
                et.setTssdpolicy(tssdpolicyService.getById(et.getTssdpolicyid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getTssdtaskid())) && et.getTssdtask() == null){
            try {
                et.setTssdtask(tssdtaskService.getById(et.getTssdtaskid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<TSSDTaskPolicy> listDefault(TSSDTaskPolicySearchFilter filter) {
		return tssdtaskpolicyMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<TSSDTaskPolicy> searchDefault(TSSDTaskPolicySearchFilter filter) {
		return tssdtaskpolicyMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return tssdtaskpolicyMapper.selectRow(sql);
    }

 }